/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT
 * Although most of the following code is written from scratch, it is
 * heavily influenced by Q (https://github.com/kriskowal/q) and uses some of Q's spec.
 */
var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)};define(["require","exports","../Types","../Threading/deferImmediate","../Disposable/DisposableBase","../Exceptions/InvalidOperationException","../Exceptions/ArgumentException","../Exceptions/ArgumentNullException","../Disposable/ObjectPool","../Collections/Set","../Threading/defer"],function(t,e,n,r,i,o,s,l,u,a,c){"use strict";function f(t){return n["default"].hasMemberOfType(t,y,n["default"].FUNCTION)}function h(t,e,n){var r=e?e(t):t;return r&&f(r)?O.wrap(r):n(r)}function p(t,e,n){try{var r=n?n(e):e;t&&t.resolve(r)}catch(i){t.reject(i)}}function d(t,e,n,r){try{var i=r?r(n):n;t&&t(i)}catch(o){e&&e(o)}}function v(t,e,n){t instanceof S?t.thenThis(e,n):t.then(e,n)}var w=void 0,g="Promise",_=g+"State",y="then",m="target",b=function(t){function e(e,n,r){t.call(this),this._state=e,this._result=n,this._error=r,this._disposableObjectName=_}return __extends(e,t),e.prototype._onDispose=function(){this._state=w,this._result=w,this._error=w},e.prototype.getState=function(){return this._state},Object.defineProperty(e.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isPending",{get:function(){return this.getState()===O.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isSettled",{get:function(){return this.getState()!=O.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isFulfilled",{get:function(){return this.getState()===O.State.Fulfilled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRejected",{get:function(){return this.getState()===O.State.Rejected},enumerable:!0,configurable:!0}),e.prototype.getResult=function(){return this._result},Object.defineProperty(e.prototype,"result",{get:function(){return this.throwIfDisposed(),this.getResult()},enumerable:!0,configurable:!0}),e.prototype.getError=function(){return this._error},Object.defineProperty(e.prototype,"error",{get:function(){return this.throwIfDisposed(),this.getError()},enumerable:!0,configurable:!0}),e}(i.DisposableBase);e.PromiseState=b;var S=function(t){function e(){t.call(this,O.State.Pending),this._disposableObjectName=g}return __extends(e,t),e.prototype.then=function(t,e){var n=this;return new O(function(r,i){n.thenThis(function(e){return d(r,i,e,t)},function(t){return e?d(r,null,t,e):i(t)})})},e.prototype.delayFromNow=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),new O(function(n,r){c.defer(function(){e.thenThis(function(t){return n(t)},function(t){return r(t)})},t)},!0)},e.prototype.delayAfterResolve=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),this.isSettled?this.delayFromNow(t):new O(function(n,r){e.thenThis(function(e){return c.defer(function(){return n(e)},t)},function(e){return c.defer(function(){return r(e)},t)})},!0)},e.prototype["catch"]=function(t){return this.throwIfDisposed(),this.then(w,t)},e.prototype["finally"]=function(t){return this.throwIfDisposed(),this.then(t,t)},e.prototype.finallyThis=function(t){this.throwIfDisposed();var e=function(){return r.deferImmediate(t)};return this.thenThis(e,e),this},e}(b);e.PromiseBase=S;var j=function(t){function e(){t.apply(this,arguments)}return __extends(e,t),e.prototype.thenSynchronous=function(t,e){this.throwIfDisposed();try{switch(this.state){case O.State.Fulfilled:return t?h(this._result,t,O.resolve):this;case O.State.Rejected:return e?h(this._error,e,O.resolve):this}}catch(n){return new P(n)}throw new Error("Invalid state for a resolved promise.")},e.prototype.thenThis=function(t,e){switch(this.throwIfDisposed(),this.state){case O.State.Fulfilled:t&&t(this._result);break;case O.State.Rejected:e&&e(this._error)}return this},e}(S);e.Resolvable=j;var x=function(t){function e(e,n,r){t.call(this),this._result=n,this._error=r,this._state=e}return __extends(e,t),e}(j);e.Resolved=x;var I=function(t){function e(e){t.call(this,O.State.Fulfilled,e)}return __extends(e,t),e}(x),P=function(t){function e(e){t.call(this,O.State.Rejected,w,e)}return __extends(e,t),e}(x),E=function(t){function e(e){var n=this;if(t.call(this),this._target=e,!e)throw new l.ArgumentNullException(m);if(!f(e))throw new s.ArgumentException(m,"Must be a promise-like object.");e.then(function(t){n._state=O.State.Fulfilled,n._result=t,n._error=w,n._target=w},function(t){n._state=O.State.Rejected,n._error=t,n._target=w})}return __extends(e,t),e.prototype.thenSynchronous=function(e,n){this.throwIfDisposed();var r=this._target;return r?new O(function(t,i){v(r,function(n){return d(t,i,n,e)},function(e){return n?d(t,null,e,n):i(e)})},!0):t.prototype.thenSynchronous.call(this,e,n)},e.prototype.thenThis=function(e,n){this.throwIfDisposed();var r=this._target;return r?(v(r,e,n),this):t.prototype.thenThis.call(this,e,n)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._target=w},e}(j),O=function(t){function e(e,n){void 0===n&&(n=!1),t.call(this),e&&this.resolveUsing(e,n)}return __extends(e,t),e.prototype.thenSynchronous=function(n,r){if(this.throwIfDisposed(),this._state)return t.prototype.thenSynchronous.call(this,n,r);var i=new e;return(this._waiting||(this._waiting=[])).push(D.PromiseCallbacks.init(n,r,i)),i},e.prototype.thenThis=function(e,n){return this.throwIfDisposed(),this._state?t.prototype.thenThis.call(this,e,n):((this._waiting||(this._waiting=[])).push(D.PromiseCallbacks.init(e,n)),this)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._resolvedCalled=w},e.prototype.resolveUsing=function(t,n,i){var s=this;if(void 0===n&&(n=!1),void 0===i&&(i=!1),!t)throw new l.ArgumentNullException("resolver");if(this._resolvedCalled)throw new o.InvalidOperationException(".resolve() already called.");if(this.state)throw new o.InvalidOperationException("Already resolved: "+e.State[this.state]);this._resolvedCalled=!0;var u=0,a=function(t){u?console.warn(-1==u?"Rejection called multiple times":"Rejection called after fulfilled."):(u=-1,s._resolvedCalled=!1,s.reject(t))},c=function(t){u?console.warn(1==u?"Fulfill called multiple times":"Fulfill called after rejection."):(u=1,s._resolvedCalled=!1,s.resolve(t))},h=function(){return t(function(t){if(t==s)throw new o.InvalidOperationException("Cannot resolve a promise as itself.");f(t)?v(t,c,a):c(t)},a)};n?h():r.deferImmediate(h)},e.prototype.resolve=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),t==this)throw new o.InvalidOperationException("Cannot resolve a promise as itself.");if(this._state){if(!n||this._state==e.State.Fulfilled&&this._result===t)return;throw new o.InvalidOperationException("Changing the fulfilled state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new o.InvalidOperationException(".resolve() already called.")}else{this._state=e.State.Fulfilled,this._result=t,this._error=w;var r=this._waiting;if(r){this._waiting=w;for(var i=0,s=r;i<s.length;i++){var l=s[i],u=l.onFulfilled,a=l.promise,c=a;D.PromiseCallbacks.recycle(l),p(c,t,u)}r.length=0}}},e.prototype.reject=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),this._state){if(!n||this._state==e.State.Rejected&&this._error===t)return;throw new o.InvalidOperationException("Changing the rejected state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new o.InvalidOperationException(".resolve() already called.")}else{this._state=e.State.Rejected,this._error=t;var r=this._waiting;if(r){this._waiting=null;for(var i=0,s=r;i<s.length;i++){var l=s[i],u=l.onRejected,a=l.promise,c=a;D.PromiseCallbacks.recycle(l),u?p(c,t,u):c.reject(t)}r.length=0}}},e}(j);e.Promise=O;var D;!function(t){var e;!function(t){function e(){return o||(o=new u.ObjectPool(40,n,function(t){t.onFulfilled=null,t.onRejected=null,t.promise=null}))}function n(){return{onFulfilled:null,onRejected:null,promise:null}}function r(t,n,r){var i=e().take();return i.onFulfilled=t,i.onRejected=n,i.promise=r,i}function i(t){e().add(t)}var o;t.init=r,t.recycle=i}(e=t.PromiseCallbacks||(t.PromiseCallbacks={}))}(D||(D={}));var O;!function(t){function e(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];if(!e&&!n.length)throw new l.ArgumentNullException("promises");var i=(Array.isArray(e)?e:[e]).concat(n);return!i.length||i.every(function(t){return!t})?new I(i):new t(function(t,e){var n=[],r=i.length;n.length=r;for(var o=new a.Set(i.map(function(t,e){return e})),s=function(){e=null,t=null,i.length=0,i=null,o.dispose(),o=null},l=function(){var e=t;e&&!o.count&&(s(),e(n))},u=function(e,r){t&&(n[r]=e,o.remove(r),l())},c=function(t){var n=e;n&&(s(),n(t))},f=function(t){var e=i[t];e?e.then(function(e){return u(e,t)},c):o.remove(t),l()},h=0;o&&r>h;h++)f(h)})}function n(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];if(!e&&!n.length)throw new l.ArgumentNullException("promises");var i=(Array.isArray(e)?e:[e]).concat(n);return!i.length||i.every(function(t){return!t})?new I(i):new t(function(t,e){for(var n=i.length,r=new a.Set(i.map(function(t,e){return e})),o=function(){e=null,t=null,r.dispose(),r=null},s=function(){var e=t;e&&!r.count&&(o(),e(i))},l=function(t){r&&(r.remove(t),s())},u=function(t){var e=i[t];e?e.then(function(e){return l(t)},function(e){return l(t)}):l(t)},c=0;r&&n>c;c++)u(c)})}function r(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];var i=e&&(Array.isArray(e)?e:[e]).concat(n);if(!i||!i.length||!(i=i.filter(function(t){return null!=t})).length)throw new s.ArgumentException("Nothing to wait for.");var o=i.length;if(1==o)return u(i[0]);for(var l=0;o>l;l++){var a=i[l];if(a instanceof S&&a.isSettled)return a}return new t(function(t,e){for(var n=function(){e=null,t=null,i.length=0,i=null},r=function(t,e){t&&(n(),t(e))},o=function(e){return r(t,e)},s=function(t){return r(e,t)},l=0,u=i;l<u.length;l++){var a=u[l];if(!t)break;a.then(o,s)}})}function i(t){return f(t)?u(t):new I(t)}function o(t){return new P(t)}function u(e){if(!e)throw new l.ArgumentNullException(m);return e instanceof t?this:new E(e)}function c(t){if(!t)throw new l.ArgumentNullException(y);return new E({then:t})}!function(t){t[t.Pending=0]="Pending",t[t.Fulfilled=1]="Fulfilled",t[t.Rejected=-1]="Rejected"}(t.State||(t.State={}));var h=t.State;Object.freeze(h),t.all=e,t.waitAll=n,t.race=r,t.resolve=i,t.reject=o,t.wrap=u,t.createFrom=c}(O=e.Promise||(e.Promise={}))});
//# sourceMappingURL=Promise.js.map
